'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _action_types = require('./action_types');

function merge(viewModel, aggregateId, state) {
    return {
        type: _action_types.MERGE,
        viewModel: viewModel,
        aggregateId: aggregateId,
        state: state
    };
}

function sendCommand(_ref) {
    var command = _ref.command,
        aggregateId = _ref.aggregateId,
        aggregateName = _ref.aggregateName,
        payload = _ref.payload;

    return {
        type: _action_types.SEND_COMMAND,
        command: command,
        aggregateId: aggregateId,
        aggregateName: aggregateName,
        payload: payload
    };
}

function subscribe(viewModel, aggregateId) {
    return {
        type: _action_types.SUBSCRIBE,
        viewModel: viewModel,
        aggregateId: aggregateId
    };
}

function unsubscribe(viewModel, aggregateId) {
    return {
        type: _action_types.UNSUBSCRIBE,
        viewModel: viewModel,
        aggregateId: aggregateId
    };
}

function provideViewModels(viewModels) {
    return {
        type: _action_types.PROVIDE_VIEW_MODELS,
        viewModels: viewModels
    };
}

exports.default = {
    merge: merge,
    sendCommand: sendCommand,
    subscribe: subscribe,
    unsubscribe: unsubscribe,
    provideViewModels: provideViewModels
};