'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _apolloClient = require('apollo-client');

var _apolloLinkHttp = require('apollo-link-http');

var _apolloCacheInmemory = require('apollo-cache-inmemory');

var _reactApollo = require('react-apollo');

var _graphqlTag = require('graphql-tag');

var _graphqlTag2 = _interopRequireDefault(_graphqlTag);

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (gqlQuery) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var endpoint = arguments[2];

    var client = new _apolloClient.ApolloClient({
        link: new _apolloLinkHttp.HttpLink({
            uri: endpoint || (0, _util.getRootableUrl)('/api/query/graphql'),
            credentials: 'same-origin'
        }),
        cache: new _apolloCacheInmemory.InMemoryCache()
    });

    return function (Component) {
        return function ResolveGraphglConnector(props) {
            var GraphQLConnector = (0, _reactApollo.graphql)((0, _graphqlTag2.default)(gqlQuery), options)(Component);

            return _react2.default.createElement(
                _reactApollo.ApolloProvider,
                { client: client },
                _react2.default.createElement(GraphQLConnector, props)
            );
        };
    };
};