'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.subscribe = exports.api = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var subscribe = exports.subscribe = function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(store, socket, viewModels, subscribers, requests, action) {
        var viewModel, aggregateId, needChange, key, rawState, state;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
            while (1) {
                switch (_context3.prev = _context3.next) {
                    case 0:
                        viewModel = action.viewModel, aggregateId = action.aggregateId;
                        needChange = !subscribers.viewModels[viewModel] || !subscribers.aggregateIds[aggregateId];


                        subscribers.viewModels[viewModel] = (subscribers.viewModels[viewModel] || 0) + 1;
                        subscribers.aggregateIds[aggregateId] = (subscribers.aggregateIds[aggregateId] || 0) + 1;

                        if (!needChange) {
                            _context3.next = 12;
                            break;
                        }

                        key = (0, _util.getKey)(viewModel, aggregateId);

                        requests[key] = true;

                        _context3.next = 9;
                        return api.getViewModelRawState(viewModel, aggregateId);

                    case 9:
                        rawState = _context3.sent;
                        state = viewModels.find(function (_ref3) {
                            var name = _ref3.name;
                            return name === viewModel;
                        }).deserializeState(rawState);


                        if (requests[key]) {
                            delete requests[key];

                            store.dispatch(_actions2.default.merge(viewModel, aggregateId, state));

                            socket.io.emit('setSubscription', {
                                types: getEventTypes(viewModels, subscribers),
                                ids: getAggregateIds(viewModels, subscribers)
                            });
                        }

                    case 12:
                    case 'end':
                        return _context3.stop();
                }
            }
        }, _callee3, this);
    }));

    return function subscribe(_x2, _x3, _x4, _x5, _x6, _x7) {
        return _ref2.apply(this, arguments);
    };
}();

exports.getEventTypes = getEventTypes;
exports.getAggregateIds = getAggregateIds;
exports.initSocketIO = initSocketIO;
exports.unsubscribe = unsubscribe;
exports.createMiddleware = createMiddleware;

var _action_types = require('./action_types');

var _actions = require('./actions');

var _actions2 = _interopRequireDefault(_actions);

var _socket = require('socket.io-client');

var _socket2 = _interopRequireDefault(_socket);

var _util = require('./util');

var _isomorphicFetch = require('isomorphic-fetch');

var _isomorphicFetch2 = _interopRequireDefault(_isomorphicFetch);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var CRITICAL_LEVEL = 100;
var REFRESH_TIMEOUT = 1000;

var api = exports.api = {
    sendCommand: function sendCommand(store, action) {
        var _this = this;

        return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
            var command, aggregateId, aggregateName, payload, normalizedCommand, response, text;
            return regeneratorRuntime.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                            command = action.command, aggregateId = action.aggregateId, aggregateName = action.aggregateName, payload = action.payload;

                            if (command && (0, _util.checkRequiredFields)({ aggregateId: aggregateId, aggregateName: aggregateName }, 'Send command error:', JSON.stringify(action)) && !(command.ok || command.error)) {
                                _context.next = 3;
                                break;
                            }

                            return _context.abrupt('return');

                        case 3:
                            normalizedCommand = {
                                type: command.type,
                                aggregateId: aggregateId,
                                aggregateName: aggregateName,
                                payload: payload
                            };
                            _context.prev = 4;
                            _context.next = 7;
                            return (0, _isomorphicFetch2.default)((0, _util.getRootableUrl)('/api/commands'), {
                                method: 'POST',
                                headers: { 'Content-Type': 'application/json' },
                                credentials: 'same-origin',
                                body: JSON.stringify(normalizedCommand)
                            });

                        case 7:
                            response = _context.sent;

                            if (!response.ok) {
                                _context.next = 11;
                                break;
                            }

                            store.dispatch(_extends({}, action, {
                                command: _extends({}, action.command, {
                                    ok: true
                                })
                            }));

                            return _context.abrupt('return');

                        case 11:
                            _context.next = 13;
                            return response.text();

                        case 13:
                            text = _context.sent;

                            // eslint-disable-next-line no-console
                            console.error('Send command error:', text);
                            throw new Error(text);

                        case 18:
                            _context.prev = 18;
                            _context.t0 = _context['catch'](4);

                            store.dispatch(_extends({}, action, {
                                command: _extends({}, action.command, {
                                    error: _context.t0
                                })
                            }));

                        case 21:
                        case 'end':
                            return _context.stop();
                    }
                }
            }, _callee, _this, [[4, 18]]);
        }))();
    },
    getViewModelRawState: function getViewModelRawState(viewModel, aggregateId) {
        var _this2 = this;

        return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
            var response;
            return regeneratorRuntime.wrap(function _callee2$(_context2) {
                while (1) {
                    switch (_context2.prev = _context2.next) {
                        case 0:
                            _context2.next = 2;
                            return (0, _isomorphicFetch2.default)((0, _util.getRootableUrl)('/api/query/' + viewModel + '?aggregateIds' + (aggregateId === '*' ? '' : '[]') + '=' + aggregateId), {
                                method: 'GET',
                                credentials: 'same-origin'
                            });

                        case 2:
                            response = _context2.sent;

                            if (response.ok) {
                                _context2.next = 5;
                                break;
                            }

                            throw new Error(response.text());

                        case 5:
                            _context2.next = 7;
                            return response.json();

                        case 7:
                            return _context2.abrupt('return', _context2.sent);

                        case 8:
                        case 'end':
                            return _context2.stop();
                    }
                }
            }, _callee2, _this2);
        }))();
    }
};

function getEventTypes(viewModels, subscribers) {
    var eventTypes = {};

    Object.keys(subscribers.viewModels).forEach(function (viewModel) {
        if (!subscribers.viewModels[viewModel]) {
            return;
        }

        var _viewModels$find$proj = viewModels.find(function (_ref) {
            var name = _ref.name;
            return name === viewModel;
        }).projection,
            Init = _viewModels$find$proj.Init,
            projection = _objectWithoutProperties(_viewModels$find$proj, ['Init']);

        Object.keys(projection).forEach(function (eventType) {
            eventTypes[eventType] = true;
        });
    });

    return Object.keys(eventTypes);
}

function getAggregateIds(viewModels, subscribers) {
    if (subscribers.aggregateIds['*'] > 0) {
        return '*';
    }

    return Object.keys(subscribers.aggregateIds).filter(function (aggregateId) {
        return subscribers.aggregateIds[aggregateId];
    });
}

function initSocketIO(store) {
    var socket = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : { failCount: 0, io: null };

    socket.io = (0, _socket2.default)(window.location.origin, {
        path: (0, _util.getRootableUrl)('/socket/')
    });

    socket.io.on('event', function (event) {
        return store.dispatch(JSON.parse(event));
    });

    socket.io.on('disconnect', function () {
        socket.failCount++;
        if (socket.failCount > CRITICAL_LEVEL) {
            window.location.reload();
        }
        initSocketIO(store, socket);
    });

    return socket;
}

function unsubscribe(store, socket, viewModels, subscribers, requests, action) {
    var viewModel = action.viewModel,
        aggregateId = action.aggregateId;


    subscribers.viewModels[viewModel] = Math.max((subscribers.viewModels[viewModel] || 0) - 1, 0);
    subscribers.aggregateIds[aggregateId] = Math.max((subscribers.aggregateIds[aggregateId] || 0) - 1, 0);

    var needChange = !subscribers.viewModels[viewModel] || !subscribers.aggregateIds[aggregateId];

    var key = (0, _util.getKey)(viewModel, aggregateId);
    delete requests[key];

    if (needChange) {
        socket.io.emit('setSubscription', {
            types: getEventTypes(viewModels, subscribers),
            ids: getAggregateIds(viewModels, subscribers)
        });
    }
}

function createMiddleware(viewModels) {
    var subscribers = {
        viewModels: {},
        aggregateIds: {}
    };

    var requests = {};

    return function (store) {
        store.dispatch(_actions2.default.provideViewModels(viewModels));

        var socket = initSocketIO(store);

        return function (next) {
            return function (action) {
                switch (action.type) {
                    case _action_types.SUBSCRIBE:
                        {
                            subscribe(store, socket, viewModels, subscribers, requests, action).catch(function (error) {
                                return setTimeout(function () {
                                    // eslint-disable-next-line no-console
                                    console.error(error);
                                    store.dispatch(action);
                                }, REFRESH_TIMEOUT);
                            });
                            break;
                        }
                    case _action_types.UNSUBSCRIBE:
                        {
                            unsubscribe(store, socket, viewModels, subscribers, requests, action);
                            break;
                        }
                    case _action_types.SEND_COMMAND:
                        {
                            api.sendCommand(store, action);
                            break;
                        }
                    default:
                }

                return next(action);
            };
        };
    };
}

var middleware = typeof window === 'undefined' ? function () {
    return function () {
        return function (next) {
            return function (action) {
                return next(action);
            };
        };
    };
} : createMiddleware;

exports.default = middleware;