'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.checkRequiredFields = checkRequiredFields;
exports.getRootableUrl = getRootableUrl;
exports.getKey = getKey;

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function checkRequiredFields(obj, beforeWarnings, afterWarnings) {
    var warningMessages = Object.keys(obj).map(function (fieldName) {
        return obj[fieldName] ? null : 'The \'' + fieldName + '\' field is required';
    }).filter(function (msg) {
        return msg;
    });

    var shouldWarningsBePrinted = warningMessages.length > 0;

    if (shouldWarningsBePrinted) {
        // eslint-disable-next-line no-console
        console.warn([beforeWarnings].concat(_toConsumableArray(warningMessages), [afterWarnings]).filter(function (line) {
            return line;
        }).join('\n'));
    }

    return !shouldWarningsBePrinted;
}

function getRootableUrl(path) {
    var rootDir = typeof process !== 'undefined' && typeof process.env !== 'undefined' && process.env.ROOT_DIR ? process.env.ROOT_DIR : '';

    return '' + rootDir + path;
}

function getKey(viewModel, aggregateId) {
    return viewModel + ':' + aggregateId;
}