'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _actions = require('./actions');

var _actions2 = _interopRequireDefault(_actions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

exports.default = function (Component) {
    var WithViewModels = function (_React$PureComponent) {
        _inherits(WithViewModels, _React$PureComponent);

        function WithViewModels(props, context) {
            _classCallCheck(this, WithViewModels);

            var _this = _possibleConstructorReturn(this, (WithViewModels.__proto__ || Object.getPrototypeOf(WithViewModels)).call(this, props, context));

            _this.state = { isMounted: false };
            return _this;
        }

        _createClass(WithViewModels, [{
            key: 'componentWillMount',
            value: function componentWillMount() {
                var _props = this.props,
                    viewModel = _props.viewModel,
                    aggregateId = _props.aggregateId;


                this.context.store.dispatch(_actions2.default.subscribe(viewModel, aggregateId));
            }
        }, {
            key: 'componentDidMount',
            value: function componentDidMount() {
                this.setState({ isMounted: true });
            }
        }, {
            key: 'componentWillUnmount',
            value: function componentWillUnmount() {
                var _props2 = this.props,
                    viewModel = _props2.viewModel,
                    aggregateId = _props2.aggregateId;


                this.setState({ isMounted: false });

                this.context.store.dispatch(_actions2.default.unsubscribe(viewModel, aggregateId));
            }
        }, {
            key: 'render',
            value: function render() {
                if (!this.state.isMounted) {
                    return null;
                }
                return _react2.default.createElement(Component, this.props);
            }
        }]);

        return WithViewModels;
    }(_react2.default.PureComponent);

    WithViewModels.contextTypes = {
        store: _propTypes2.default.object.isRequired
    };

    return WithViewModels;
};